package
{
import flash.display.DisplayObject;
import mx.core.IInvalidating;
import flexCustomControlClasses.FlexCustomControlEvent;
import mx.automation.IAutomationObject;
import mx.automation.AutomationIDPart;
import mx.automation.delegates.core.UIComponentAutomationImpl;
import mx.automation.IAutomationObjectHelper;
import mx.automation.Automation;
import mx.automation.events.AutomationRecordEvent;
import flash.events.Event;

[Mixin]
public class FlexCustomControlDelegate extends UIComponentAutomationImpl
{
	private var walker:FlexCustomControl

	public function FlexCustomControlDelegate(flexCustomControl:FlexCustomControl)
	{
 		 super(flexCustomControl);
		 flexCustomControl.addEventListener(FlexCustomControlEvent.ITEM_CLICK, itemClickHandler);
		 flexCustomControl.addEventListener(AutomationRecordEvent.RECORD, labelRecordHandler);
		 walker = flexCustomControl;
	}


	public static function init(obj:DisplayObject):void
	{
   		Automation.registerDelegateClass(FlexCustomControl, FlexCustomControlDelegate);
		
	}
	
	private function itemClickHandler(event:FlexCustomControlEvent):void 
	{
		 
 		 recordAutomatableEvent(event);
	}
	public function labelRecordHandler(event:AutomationRecordEvent):void 
	{
 		 // if the event is not from the owning component reject it.	
		 if(event.replayableEvent.target != uiComponent)
   	        //event.preventDefault(); can also be used.
    		event.stopImmediatePropagation();
	}
	override public function get numAutomationChildren():int 
	{
		var numChildren:int = 0;
 		var renderers:Array = walker.getItemRenderers();
 		for(var i:int = 0;i< renderers.length;i++) 
		{
 		  numChildren += renderers[i].length;
 		}
		return numChildren;
	}
	override public function getAutomationChildAt(index:int):IAutomationObject 
	{
 		var numChildren:int = 0;
		var renderers:Array = walker.getItemRenderers();
 		for(var i:int = 0;i < renderers.length;i++) 
 		{
  		    if(index >= numChildren) 
   		    {
    			    if(i+1 < renderers.length && (numChildren + renderers[i].length) <= index) 
    			    {
    			       numChildren += renderers[i].length;
    			       continue;
     			    }

        		    var subIndex:int = index - numChildren;
     			    var instances:Array = renderers[i];		
			    return (instances[subIndex] as IAutomationObject);
    		     }
  		}
   	return null;
	}
	override public function createAutomationIDPart(child:IAutomationObject):Object
	{
		 var help:IAutomationObjectHelper = Automation.automationObjectHelper;
		 return help.helpCreateIDPart(walker, child);   
	}   
    
	override public function resolveAutomationIDPart(part:Object):Array    
	{  		
		 var help:IAutomationObjectHelper = Automation.automationObjectHelper; 
		 return help.helpResolveIDPart(walker, part as AutomationIDPart);   
	} 
	override public function replayAutomatableEvent(event:Event):Boolean 
	{
   		 var help:IAutomationObjectHelper = Automation.automationObjectHelper;
    		 if (event is FlexCustomControlEvent) 
    		 {
      		   var rEvent:FlexCustomControlEvent = event as FlexCustomControlEvent
       		   help.replayClick(rEvent.itemRenderer);
       		  (uiComponent as IInvalidating).validateNow();
       		  return true;
     		 } 
     		 else
      		 return super.replayAutomatableEvent(event);
	}

}
}