@ECHO OFF
REM #
REM # IBM Confidential 
REM #	
REM #   (c) Copyright IBM Corp. 2000, 2008 All Rights Reserved.
REM #
REM #   The source code for this program is not published or otherwise
REM #   divested of its trade secrets, irrespective of what has been 
REM #   deposited with the U.S. Copyright Office.

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::   
:: OVERVIEW:
:: Note this script is called to start the RQM adapter.
::
:: USAGE  startadapter.bat 
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
SET RFT_DEBUG_OUTPUT=..false..

SET RFT_THIS_BATCH_FILES_DIR=%~dp0
SET RFT_ARG_JRE=..undefined..
SET RFT_JVM_ARGS=..undefined..
SET RFT_RREG_DIR=..undefined..
SET RFT_RREG=rreg.exe
SET RFT_INSTALL_DIR=..undefined..


shift
CALL :Setrreg
CALL :SetInstallDir
CALL :SetJre
CALL :SetRqmMode
CALL :RunAdapter %*
GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: setrreg - Set the rreg variable which will point to the rreg.exe. This will help  
:: to get the registry variables.
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:Setrreg
IF %RFT_RREG_DIR% NEQ ..undefined.. (
	GOTO :EOF
)
IF EXIST "%RFT_THIS_BATCH_FILES_DIR%..\installscripts\%RFT_RREG%"	(
	SET RFT_RREG_DIR="%RFT_THIS_BATCH_FILES_DIR%..\installscripts"
) ELSE ( 
	IF EXIST "%IBM_RATIONAL_RFT_INSTALL_DIR%\..\installscripts\%RFT_RREG%"	(
		SET RFT_RREG_DIR="%IBM_RATIONAL_RFT_INSTALL_DIR%\..\installscripts"
	) ELSE (
		IF EXIST "%RFT_THIS_BATCH_FILES_DIR%\%RFT_RREG%"	(
			Set RFT_RREG_DIR="%RFT_THIS_BATCH_FILES_DIR%"
		) 
	)
)
CALL :Debug Set RFT_RREG_DIR=%RFT_RREG_DIR%
GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: setInstallDir
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: 
:SetInstallDir
IF %RFT_INSTALL_DIR% NEQ ..undefined.. (
	GOTO :EOF
)
IF EXIST "%IBM_RATIONAL_RFT_INSTALL_DIR%" (
	Set RFT_INSTALL_DIR="%IBM_RATIONAL_RFT_INSTALL_DIR%"
) ELSE (
	@CALL :QueryRftReg "Rational FT Install Directory"
	@IF "%RFT_REG_VALUE%" NEQ "" (
		Set RFT_INSTALL_DIR="%RFT_REG_VALUE%"
	)
)
CALL :Debug Set RFT_INSTALL_DIR=%RFT_INSTALL_DIR%
GOTO :EOF
	
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: setjre
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::: 
:SetJre
IF %RFT_ARG_JRE% NEQ ..undefined.. (
	GOTO :EOF
)
@CALL :QueryRftReg "Rational FT JRE"
@IF "%RFT_REG_VALUE%" NEQ "" (
	IF EXIST "%RFT_REG_VALUE%\bin\javaw.exe" (
		Set RFT_ARG_JRE="%RFT_REG_VALUE%"\bin\javaw.exe
		GOTO :EOF
	)
)
@CALL :QueryRftReg "Rational FT Install Directory"  
@IF "%RFT_REG_VALUE%" NEQ "" (
	IF EXIST "%RFT_REG_VALUE%\..\..\jdk\jre\bin\javaw.exe" (
		Set RFT_ARG_JRE="%RFT_REG_VALUE%"\..\..\jdk\jre\bin\javaw.exe
		GOTO :EOF
	)
	IF EXIST "%RFT_REG_VALUE%\..\..\jre\bin\javaw.exe" (
		Set RFT_ARG_JRE="%RFT_REG_VALUE%"\..\..\jre\bin\javaw.exe
		GOTO :EOF
	)
)
IF "%RFT_INSTALL_DIR%" NEQ "..undefined.." (
	IF EXIST "%RFT_INSTALL_DIR%\..\..\jdk\jre\bin\javaw.exe" ( 
		Set RFT_ARG_JRE=%RFT_INSTALL_DIR%\..\..\jdk\jre\bin\javaw.exe
		GOTO :EOF
	)
	IF EXIST "%RFT_INSTALL_DIR%\..\..\jre\bin\javaw.exe" ( 
		Set RFT_ARG_JRE=%RFT_INSTALL_DIR%\..\..\jre\bin\javaw.exe
		GOTO :EOF
	)
)
IF "%JAVA2_HOME%" NEQ "" (
	IF EXIST "%JAVA2_HOME%\jre\bin\javaw.exe" ( 
		Set RFT_ARG_JRE=%JAVA2_HOME%\jre\bin\javaw.exe
		GOTO :EOF
	)
)
Set RFT_ARG_JRE=javaw.exe
GOTO :EOF

:SetRqmMode
Set rqm_mode=true
GOTO :EOF

:RunAdapter
@ECHO Running %RFT_ARG_JRE% -classpath %RFT_INSTALL_DIR%\rational_ft.jar com.rational.test.ft.RQMAdapterLauncher %*
start "" %RFT_ARG_JRE% -classpath %RFT_INSTALL_DIR%\rational_ft.jar com.rational.test.ft.RQMAdapterLauncher %*
GOTO :EOF


::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					   Query Registry Variable
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:QueryReg
	IF %RFT_RREG_DIR% EQU "..undefined.." (
		@GOTO :EOF
	)

	@REM # CALL :Debug === QueryReg %1 %2
	SET RFT_REG_VALUE=
	pushd %RFT_RREG_DIR%
	for /f "delims== tokens=1-3" %%i in ('%RFT_RREG% query %1 /v %2 /p') do @SET RFT_REG_VALUE=%%j
	popd
	CALL :DEBUG Registry %2="%RFT_REG_VALUE%"
	@GOTO :EOF


::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: 					   Query RFT Registry Variable
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:QueryRftReg
	@CALL :QueryReg "HKLM\SOFTWARE\Rational Software\Rational Test\8" %1
	@GOTO :EOF


::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Debug  Message
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:Debug
	@if %RFT_DEBUG_OUTPUT% EQU ..true.. (
		@ECHO DEBUG--- %*
	)
	@GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Error Message
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:Error
	set ERR_CODE=..error..
	@ECHO ERROR - %*
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Error Message
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:ErrorNoStop
	set ERR_CODE=..success..
	@ECHO ERROR - %*
	GOTO :EOF

::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:: Warning
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
:Warning
	set ERR_CODE=..success..
	@ECHO WARNING - %*
	GOTO :EOF

:LAST
@echo "---------------------------------------------------------------------"
