<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    version="1.0"
    xmlns:xalan="http://xml.apache.org/xslt">
	
    <xsl:output method="html"/>	      
    <xsl:param name="dojoJSLocation" select="'../Log_Assistive_Files/dojo.js'"/>
    <xsl:param name="logAssistiveLocation" select="'../Log_Assistive_Files'"/>
    
	<xsl:param name="rft.testlog.lpane.testverdict.headline" select="'Test Verdict'"/>
	<xsl:param name="rft.testlog.lpane.testverdict.tree.headline" select= "'Verdict'" />
	<xsl:param name="rft.testlog.lpane.vp.headline" select = "'Verification Points'"/>
	<xsl:param name="rft.testlog.lpane.failure.headline" select = "'Failure Verdicts'"/>
	<xsl:param name="rft.testlog.lpane.warning.headline" select = "'Warning Verdicts'" />
	<xsl:param name="rft.testlog.rpane.dp.headline" select = "'Datapool Values'"/>
	<xsl:param name="rft.testlog.rpane.totalverdict.headline" select = "'Overall Verdict'" />
	<xsl:param name="rft.testlog.rpane.totalverdict.pass" select = "'Success'"/>
	<xsl:param name="rft.testlog.rpane.totalverdict.fail" select = "'Failures'"/>
	<xsl:param name="rft.testlog.rpane.totalverdict.warn" select = "'Warnings'"/>
	<xsl:param name="rft.testlog.rpane.totalverdict.info" select = "'Messages'" />
	<xsl:param name="rft.testlog.rpane.totalverdict.vp.pass" select = "'Successful Verification Points'"/>
	<xsl:param name="rft.testlog.rpane.totalverdict.vp.fail" select = "'Failed Verification Points'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.vp.viewresult" select = "'View Results'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.pass" select = "'PASS'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.fail" select = "'FAIL'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.warn" select = "'WARNING'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.info" select = "'INFORMATION'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.snapshot.click" select = "'Click to view full size'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.vp.type" select = "'Verification Point Type'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.vp.actual" select = "'Actual Verification Point'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.vp.expected" select = "'Expected Verification Point'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.vp.baseline" select = "'Baseline Verification Point'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.exception.name" select = "'Exception Name'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.exception.message" select = "'Exception Message'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.exception.stack" select = "'Exception Stack'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.snapshot" select= "'Screen Snapshot'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.user.snapshot" select = "'User Screen Snapshot'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.script.line" select = "'Line Number'" />
	<xsl:param name="rft.testlog.rpane.resulttable.script.name" select = "'Script Name'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.script.id" select = "'Script ID'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.prop.name" select = "'Property Name'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.additionalinfo" select = "'Additional Info'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.failure.desc" select = "'Failure Description'" />
	<xsl:param name="rft.testlog.rpane.resulttable.script.itercount" select = "'Iteration Count'"/>   
	<xsl:param name="rft.testlog.rpane.resulttable.script.ss_line_number" select = "'SimplifiedScript Line Number'"/> 
	<xsl:param name="rft.testlog.rpane.resulttable.script.ss_line" select = "'SimplifiedScript Line'"/> 
	<xsl:param name="rft.testlog.rpane.resulttable.script.ss_group_name" select = "'SimplifiedScript Group Names'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.script.sa_executable" select = "'StartApp Executable'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.script.sa_args" select = "'StartApp Arguments'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.script.sa_work_dir" select = "'StartApp Working Directory'"/>
    	<xsl:param name="rft.testlog.rpane.resulttable.script.sa_app_type" select = "'Application Type'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.script.property_name" select = "'Property Name'"/>
	<xsl:param name="rft.testlog.rpane.resulttable.script.property_value" select = "'Property Value'"/>
    	<xsl:param name="rft.testlog.rpane.resulttable.script.assigned_variable_name" select = "'Assigned Variable Name'"/>
    <xsl:variable name="singleQuote"><xsl:text>'</xsl:text></xsl:variable>
	<xsl:param name="index" select="1"/>
    <xsl:template match="TestLog">	
	<HTML>
	<HEAD>
	<script type="text/javascript" src="{$dojoJSLocation}" djConfig="parseOnLoad: true" />
	<link rel="stylesheet" type="text/css" href="{$logAssistiveLocation}/log.css"/>		
	<script type="text/javascript">
	
	<xsl:if test="$dojoJSLocation = '../Log_Assistive_Files/dojo.js'">
		var dojoLocation = location.search;
		
		if(dojoLocation)
		{	
			dojoLocation = dojoLocation.substr(1);
			dojoLocation = dojoLocation.replace(/\\/g,"/");
			dojoLocation = "file:///" + dojoLocation;
			var dojoRoot = dojoLocation.replace(/\/dojo\/dojo.js/,"");
			var dojoDir = dojoRoot + "/dojo";
			var dijitDir = dojoRoot + "/dijit";
			var dojoxDir = dojoRoot + "/dojox";

			dojo.registerModulePath("dojo",dojoDir);
			dojo.registerModulePath("dijit",dijitDir);
			dojo.registerModulePath("dojox",dojoxDir);	
	
		</xsl:if>	
			var dojoCSS = dojo.moduleUrl("dojo","resources/dojo.css");
			var stl1 = document.createElement("link");
			stl1.type = "text/css";
			stl1.rel="stylesheet";
			stl1.href = dojoCSS.toString();

			var tundraCSS= dojo.moduleUrl("dijit","themes/tundra/tundra.css");
			var stl2 = document.createElement("link");
			stl2.type = "text/css";
			stl2.rel="stylesheet";
			stl2.href = tundraCSS.toString();



			document.getElementsByTagName("head")[0].appendChild(stl1);
			document.getElementsByTagName("head")[0].appendChild(stl2);

	
			dojo.require("dijit.layout.AccordionContainer");
			dojo.require("dijit.Tree");
			dojo.require("dojo.data.ItemFileReadStore");
			dojo.require("dijit.layout.SplitContainer");
			dojo.require("dijit.layout.ContentPane");
			dojo.require("dijit.layout.LayoutContainer");
			dojo.require("dijit.layout.StackContainer");
			dojo.require("dijit.TitlePane");
			dojo.require("dojox.fx.scroll");
			dojo.require("dojox.fx.easing");
			dojo.require("dojo.data.ItemFileWriteStore");
			dojo.require("dojox.fx");
			dojo.require("dojox.charting.widget.Chart2D");			
			dojo.require("dojox.charting.themes.PlotKit.blue");	
			dojo.require("dijit.Toolbar");
			dojo.require("dijit.form.Button");
			dojo.require("dijit.form.CheckBox");

			dojo.provide("rft.Tree");
			dojo.declare("rft.Tree",[dijit.Tree],
			{
				onClick: function( item,  node)
					{
						if(item != null)
						{
							var idValue = this.store.getValue(item,"eventId");
							if(isRoot(idValue))
								idValue = idValue.substring(0, idValue.lastIndexOf("_root") );
							updateDatapool(this.store,item);
							var node = dojo.byId(idValue);
							var nodeDim = dojo.coords(node);
							var tg = { x: nodeDim.l, y: nodeDim.t };
			
							dojox.fx.smoothScroll({ node: node, win: dojo.byId("RightVerdictDetailPane"), target: tg, easing:dojox.fx.easing.easeOut , duration: 400}).play();
							node.style.backgroundColor = "#FFFFFF";
							dojox.fx.highlight({node:node, color:'#0066FF', duration:800}).play();
							node.style.backgroundColor = "transparent";
						}	
						else
						{
							//This is the root node.
						}
					},
					getIconClass: function(item)
					{
						if(item != null)
						{							
						var eventType = this.store.getValue(item,"Type");
						var result = this.store.getValue(item,"Result");

						if(eventType == "Simplified Script Group"){

									if(result == "PASS") {
									
										return "ssGrpPassIcon";			
									}else if(result == "FAIL"){

										return "ssGrpFailIcon";			
									}else if(result == "WARNING"){
		
										return "ssGrpWarnIcon";			
									}else{
										return "ssGrpPassIcon";
									}
						}
						else if(eventType == "Script Start")
							{
								return "scriptStartIcon";
							}
							else if(eventType == "Verification Point")
							{
							if( result == "PASS")
								return "vpPassIcon";			
							else if(result == "FAIL")
								return "vpFailIcon";
							else if(result == "WARNING")
								return "warningIcon";
							else
								return "informationIcon";
							}
							else
							{
								if( result == "PASS")
									return "passIcon";			
								else if(result == "FAIL")
									return "failureIcon";
								else if(result == "WARNING")
									return "warningIcon";
								else
									return "informationIcon";
							}		

						}
						else
						{
							return "verdictTreeIcon";								
						}

					},
					<!--getLabel: function(/*dojo.data.Item*/ item)	 
					{
						//This function is overwritten as Javascript dosen;t have mechanism to convert unicode to ascii.
						if(item != null)
						{
							var id = this.store.getValue(item,"eventId");
							var type = this.store.getValue(item,"Type");
							if(id != null)
							{
  	  						  if(isRoot(id))
								id = id.substring(0, id.lastIndexOf("_root") );

							  var headlinerow = document.getElementById(id);
							  //The headline is part of the third cell value.
							 if(headlinerow !=null){
							  if(headlinerow.cells[2] !=null)							
							  	{
							  		if(type=='Simplified Script Group'){
							  		var result = headlinerow.cells[2].innerHTML + '[' + headlinerow.cells[0].innerHTML +']';
							  		if(headlinerow.cells[1].innerHTML == ''){
							  			return result;
							  		}else{
							  			return result + '['+headlinerow.cells[1].innerHTML + ']';
							  		}
							  	}
							  	return headlinerow.cells[2].innerHTML;		
							  	}	
							  else
							  	return null;		
							  	}else
							  	return null;		  
							}
						  }
						  
					},-->
					getLabelClass: function(item){
						if(item != null)
						{							
						var eventType = this.store.getValue(item,"Type");
						var result = this.store.getValue(item,"Result");

						if(eventType == "Simplified Script Group"){

									if(result == "PASS") {
										return 'ssGrpPassClass';			
									}else if(result == "FAIL"){

										return 'ssGrpFailClass';			
									}else if(result == "WARNING"){
		
										return 'ssGrpWarnClass';			
									}else{
										return 'ssGrpPassClass';
									}
						}
						}							
					},					
					getItemChildren: function( parentItem,  onComplete)
							 {
								 if(parentItem == null)
								 {
									 this.store.fetch({query: this.query, onComplete: onComplete});
								 }
								 else
								 {

									 var childItems = [];
										var temp1 = [];	
										var temp = this.store.getValues(parentItem, this.childrenAttr[0]);
										var j= 0;
										var tempStore123 =this.store;
										 dojo.forEach(temp,function(temp2){
												 if(isItemNonFiltered(tempStore123,temp2))
												 {
												 temp1[j]=temp2;
												 j= j +1;
												 }
												});
									 childItems= childItems.concat(temp1);
								 	onComplete(childItems);

								 }
							}


						});
			
	var dpStore = {
					identifier: 'dpId',
					items: []
					};	
	var dpLogStore = new dojo.data.ItemFileWriteStore({data : dpStore});
	
	<xsl:apply-templates select="Event/Event" mode="dpStore"></xsl:apply-templates>

	var logStore = {
						identifier: 'eventId',
						label: 'Headline',
						items: [
						<xsl:for-each select="Event">
						<xsl:apply-templates select="." mode="treeElements1"></xsl:apply-templates>
						</xsl:for-each>
						
						
						]};
	<xsl:text disable-output-escaping="yes">
	<![CDATA[
	var tempStore = {identifier: 'eventId', label: 'Headline', items: []};
	var temp1Store = {identifier: 'eventId', label: 'Headline', items: []};
	var temp2Store = {identifier: 'eventId', label: 'Headline', items: []};
	
	var failedVerdictStore = new dojo.data.ItemFileWriteStore({data : tempStore});
	var warningVerdictStore = new dojo.data.ItemFileWriteStore({data : temp1Store});
	var verificationPointStore = new dojo.data.ItemFileWriteStore({data : temp2Store});
	
	var verdictSuccess = 0;
	var verdictFailures = 0;
	var verdictWarnings = 0;
	var verdictMessages = 0;
	
	var verdictVPSuccess = 0;
	var verdictVPFailures = 0;
	
	function getRFTEventType(item)
	{
		return continentStore.getValue(item,"eventType");
	}
	function getEventID(item)
	{
		return continentStore.getValue(item,"eventId");
	}

	function getEventTimeStamp(item)
	{
		return continentStore.getValue(item,"TimeStamp");
	}

	function getEventHeadline(item)
	{
		return continentStore.getValue(item,"Headline");
	}
	function getEventType(item)
	{
		return continentStore.getValue(item,"Type");
	}
	function getEventResult(item)
	{
		return continentStore.getValue(item,"Result");
	}
	function getEventParentId(item)
	{
		return continentStore.getValue(item,"ParentId");
	}
	function getEventPosition(item)
	{
			return continentStore.getValue(item,"Position");
	}

	function populateFailures(item)
	{
		failedVerdictStore.newItem({eventType: getRFTEventType(item), eventId: getEventID(item), TimeStamp: getEventTimeStamp(item), Headline: getEventHeadline(item), Type: getEventType(item), Result: getEventResult(item), Position: getEventPosition(item), ParentId: getEventParentId(item) });
		verdictFailures = verdictFailures + 1;
	}

	function populateWarnings(item)
	{
		warningVerdictStore.newItem({eventType: getRFTEventType(item), eventId: getEventID(item), TimeStamp: getEventTimeStamp(item), Headline: getEventHeadline(item), Type: getEventType(item), Result: getEventResult(item), Position: getEventPosition(item), ParentId: getEventParentId(item) });
		verdictWarnings = verdictWarnings  + 1;
	}

	function populateSuccess(item)
	{
		verdictSuccess = verdictSuccess + 1;	
	}
	
	function populateInformation(item)
	{
		verdictMessages = verdictMessages + 1;
	}
	
	function populateVerificationPoints(item)
	{
		var verdict =  getEventResult(item);
		verificationPointStore.newItem({eventType: getRFTEventType(item), eventId: getEventID(item), TimeStamp: getEventTimeStamp(item), Headline: getEventHeadline(item), Type: getEventType(item), Result: getEventResult(item), Position: getEventPosition(item), ParentId: getEventParentId(item) });
		if(verdict == "PASS")
		{
			verdictVPSuccess = verdictVPSuccess + 1;
		}else if(verdict == "FAIL")
		{
			verdictVPFailures = verdictVPFailures + 1;
		}
	}

	function routeItems(item)
	{
		if(item != null && !isRoot( getEventID(item) ) )
		{
			var verdict = getEventResult(item);
				
			if(verdict == "FAIL")
			{
				populateFailures(item);
			}
			else if(verdict == "WARNING")
			{
				populateWarnings(item);
			}
			else if(verdict == "PASS")
			{
				populateSuccess(item);
			}
			else if(verdict == "INFORMATION")
			{
				populateInformation(item);
			}
			var verificationPoint = getEventType(item);
			if(verificationPoint == "Verification Point")
			{
				populateVerificationPoints(item);
			}
		}	
	}
function failed(error)
{
	alert(error);
}

function isRoot(idValue)
{
var index = idValue.lastIndexOf("_root");
return (index > 1);
}

var continentStore = new dojo.data.ItemFileReadStore({data: logStore});
continentStore.fetch({query :{eventType: "*"}, queryOptions :{ignoreCase: "true", deep: "true"}, onItem: routeItems, onError: failed });
function updateDatapool(store,item)
{
	var parentIdValue = store.getValue(item,"ParentId");
	var position = store.getValue(item,"Position");
	var index = parentIdValue.lastIndexOf("_root");
	if(index > 1)
		parentIdValue = parentIdValue.substring(0,index);
	var dpValue = parentIdValue.replace(/event_/,"dp_");
	
	dpLogStore.fetchItemByIdentity({identity: dpValue, onItem: function(item){

				deleteStaleDatapool();
				var dpData = dpLogStore.getValues(item,"dpUpdates")
				
				var dpVariableList = new Array();
				
				for(var i=0;i<dpData.length;i++)
				{
				var j = 0;
				if(dpData[i].dpVariable && parseInt(dpData[i].CPosition) <= parseInt(position))
				{
					for(j=0;j<dpVariableList.length;j++)
					{
						if(dpVariableList[j].dpVariable == dpData[i].dpVariable)
						{							
							break;									
						}
					}
					
					dpVariableList[j] = dpData[i];				
				}
				}	

				var variableRow = dojo.byId("dpVariable");
				var valueRow = dojo.byId("dpValue");
				for(var i=0;i<dpVariableList.length;i++)
				{				
					var cell=  variableRow.insertCell(i);
					cell.innerHTML = dpVariableList[i].dpVariable;

					var cell1=  valueRow.insertCell(i);
					cell1.innerHTML = dpVariableList[i].dpValue;
				}


			}});	
}

function deleteStaleDatapool()
{
	var dpVariable = dojo.byId("dpVariable");
	var dpValue = dojo.byId("dpValue");	
	var num = dpVariable.cells.length;
	for(var i=0;i<num;i++)
	{
		dpVariable.deleteCell(0);
		dpValue.deleteCell(0);
	}
}

function getSuccessCount()
{
	return verdictSuccess;
}

function getFailuresCount()
{
	return verdictFailures;
}

function getWarningsCount()
{
	return verdictWarnings;
}

function getMessagesCount()
{
	return verdictMessages;
}

function getFailuresVPCount()
{
	return verdictVPFailures;
}

function getSuccessVPCount()
{
	return verdictVPSuccess;
}


var totalVerdict = new Array();
totalVerdict.push(verdictSuccess);
totalVerdict.push(verdictFailures);
totalVerdict.push(verdictWarnings);
totalVerdict.push(verdictMessages);



var passFilterEnabled = true;
var failFilterEnabled = true;
var warningFilterEnabled = true;
var messageFilterEnabled = true;

function passFilterChecked(checked)
{
	passFilterEnabled = checked;
	refreshTree();
}

function failureFilterChecked(checked)
{
	failFilterEnabled = checked;
	refreshTree();
}
function warningFilterChecked(checked)
{
	warningFilterEnabled = checked;
		refreshTree();
}
function messageFilterChecked(checked)
{
	messageFilterEnabled = checked;
		refreshTree();
}

function refreshTree()
{
	var verdictTree = dijit.byId("LeftVerdictOverviewTreePane");
	if(verdictTree != null)
	{
		var newStore = verdictTree.store;
		var childAttr = verdictTree.childrenAttr;
		var label = verdictTree.label;
		var query = verdictTree.query;
		var id = "LeftVerdictOverviewTreePane";
		var labelAttr = verdictTree.labelAttr; 
		
		verdictTree.destroy();

		var newTree = new rft.Tree({ store : newStore,label: label, labelAttr: labelAttr, childrenAttr:childAttr , query:query , id:id });

		dojo.byId("LeftVerdictOverviewPane").appendChild(newTree.domNode,1);
		
	}
}
function isItemNonFiltered(store,item)
{
	var verdict = store.getValue(item,"Result");
	if(verdict == "PASS")
	{
		return passFilterEnabled;
	}else if(verdict == "FAIL")
	{
		return failFilterEnabled;
	}else if(verdict == "WARNING")
	{
		return warningFilterEnabled;
	}else if(verdict == "INFORMATION")
	{
		return messageFilterEnabled;
	}
	else
	{
		return false;
	}	
}
function comparator(base,exp,act)
{
	try{
		var url = document.URL;
		var index = url.indexOf("?");
		if(index > 1)
			url = url.substr(0,index);
		document.ComparatorApplet.startComparatorEx(base,exp,act,url);
	}
	catch(e){
		alert("CRFCN0309E: Error creating verification point display:\nAn enabled JRE (1.3.1_02 or better) must be associated with the browser to view VP results");
	}
}

function toggleFilterCheckbox(id)
{
	var filterCkb = dijit.byId(id);
	if(filterCkb != null)
		filterCkb.setChecked(!filterCkb.checked);
}

var rftTheme =  dojox.charting.themes.PlotKit.blue;
rftTheme.defineColors({colors: ["#006400","#8b0000","#b8860b","#008b8b"]});

]]>
</xsl:text>

<xsl:if test="$dojoJSLocation = '../Log_Assistive_Files/dojo.js'">
}
</xsl:if>
</script>
	
	</HEAD>	
	<BODY class="tundra">
		<div id="TopPane" dojoType="dijit.layout.LayoutContainer" style="width: 100%; height:100%; overflow: auto;">
		
		<div dojoType="dijit.layout.ContentPane" class="top" layoutAlign="top" id="banner" width="100%" height="46px">
			<img height="46px" width="80px" src="{$logAssistiveLocation}/IBM_logo_banner.gif" align="right" border="0"/>
		</div>		
		<div id="VerdictPane" dojoType="dijit.layout.SplitContainer" layoutAlign="client" orientation="horizontal" sizerWidth="5" activeSizing="0">
		
			<div id="LeftVerdictOverviewContainer" dojoType="dijit.layout.SplitContainer" orientation="vertical" sizerWidth="5" activeSizing="0" sizeShare="20" sizeMin="20">
				<div id="LeftVerdictOverviewPane" dojoType="dijit.layout.ContentPane" sizeShare="60">
					<div id="LeftVerdictOverviewDescPane" dojoType="dijit.TitlePane" open="true"  title="{$rft.testlog.lpane.testverdict.headline}" >
					Select the filter	
					
					<div id="verdictFilterToolbar1" dojoType="dijit.Toolbar" >
												
						<div dojoType="dijit.form.Button" id="successFilter" iconClass="passIcon" onClick="toggleFilterCheckbox('successFilterCkb')" showLabel="true"><xsl:value-of select="$rft.testlog.rpane.totalverdict.pass"/></div>
						<div dojoType="dijit.form.CheckBox" id="successFilterCkb" onChange="passFilterChecked" checked="checked"></div>						
						<span dojoType="dijit.ToolbarSeparator"></span>	
						<div dojoType="dijit.form.Button" id="failureFilter" iconClass="failureIcon" onClick="toggleFilterCheckbox('failureFilterCkb')" showLabel="true" ><xsl:value-of select="$rft.testlog.rpane.totalverdict.fail"/></div>
						<div dojoType="dijit.form.CheckBox" id="failureFilterCkb" onChange="failureFilterChecked" checked="checked" ></div>			
	
						<span dojoType="dijit.ToolbarSeparator"></span>	
						<div dojoType="dijit.form.Button" id="warningFilter" iconClass="warningIcon" onClick="toggleFilterCheckbox('warningFilterCkb')" showLabel="true"><xsl:value-of select="$rft.testlog.rpane.totalverdict.warn"/></div>
						<div dojoType="dijit.form.CheckBox" id="warningFilterCkb" onChange="warningFilterChecked" checked="checked"></div>			
					
						<span dojoType="dijit.ToolbarSeparator"></span>	
						<div dojoType="dijit.form.Button" id="messageFilter" iconClass="informationIcon" onClick="toggleFilterCheckbox('messageFilterCkb')" showLabel="true"><xsl:value-of select="$rft.testlog.rpane.totalverdict.info"/></div>
						<div dojoType="dijit.form.CheckBox" id="messageFilterCkb" onChange="messageFilterChecked" checked="checked"></div>
					
			</div>					
					
					
					</div>
					<div id="LeftVerdictOverviewTreePane" dojoType="rft.Tree" store="continentStore" query="{{eventType: 'rftevent'}}" label="{$rft.testlog.lpane.testverdict.tree.headline}" openOnClick="true" childrenAttr="events">
						
					</div>
				</div>
				
				<div id="LeftVerdictSpecificsContainer" dojoType="dijit.layout.AccordionContainer" duration="200" sizeMin="20" sizeShare="40">
					<div id="LeftVerdictVerificationPane" dojoType="dijit.layout.AccordionPane" title="{$rft.testlog.lpane.vp.headline}">
						<div id="LeftVerdictVerificationTree" dojoType="rft.Tree" store="verificationPointStore"></div>
					</div>
					<div id="LeftVerdictFailuresPane" dojoType="dijit.layout.AccordionPane" title="{$rft.testlog.lpane.failure.headline}">
						<div id="LeftVerdictFailureTree" dojoType="rft.Tree" store="failedVerdictStore"></div>
					</div>				
					<div id="LeftVerdictWarningsPane" dojoType="dijit.layout.AccordionPane" title="{$rft.testlog.lpane.warning.headline}">
						<div id="LeftVerdictWarningTree" dojoType="rft.Tree" store="warningVerdictStore" ></div>
					</div>				
				</div>
			</div>				
			
			<div id="RightVerdictDetailContainer" dojoType="dijit.layout.SplitContainer" orientation="vertical"  sizerWidth="5" sizeShare="80" activeSizing="0">									
						<div id="RightVerdictDetailPane" dojoType="dijit.layout.ContentPane" layoutAlign="top" sizeShare="90"> 
							<div id="RightVerdictDetailOverview" dojoType="dijit.TitlePane" open="true" title="{$rft.testlog.rpane.totalverdict.headline}">
								<table width="100%" rules="rows">
									<tr>
										<td ROWSPAN = "2" width="300">
											<div  layoutAlign="centre" dojoType="dojox.charting.widget.Chart2D" theme="rftTheme" id="RightVerdictOverviewChart" style="overflow-x:hidden;overflow-y:hidden;width: 300px; height: 300px;">
													<div class="plot" name="default" type="Pie" radius="100" fontColor="white" htmlLabels="false"></div>
													<div class="series" name="Overall Verdict" array="totalVerdict"></div>
											</div>
										</td>
										<td>
											<table >
												<tr>
													<td class="passIcon" width="10px"></td>
													<td><div class="pass"><xsl:value-of select="$rft.testlog.rpane.totalverdict.pass"/></div></td>
													<td>:</td>
													<td><div class="pass" id="SuccessList"></div></td>
												</tr>
												<tr>
													<td class="failureIcon" width="10px"></td>
													<td><div class="fail"><xsl:value-of select="$rft.testlog.rpane.totalverdict.fail"/></div></td>
													<td>:</td>
													<td align="center"><div class="fail" id="FailureList"></div></td>
												</tr>
												<tr>
													<td class="warningIcon" width="10px"></td>
													<td><div class="warn"><xsl:value-of select="$rft.testlog.rpane.totalverdict.warn"/></div></td>
													<td>:</td>
													<td><div class="warn" id="WarningList"></div></td>
												</tr>
												<tr>
													<td class="informationIcon" width="10px"></td>
													<td><div class="info"><xsl:value-of select="$rft.testlog.rpane.totalverdict.info"/></div></td>
													<td>:</td>
													<td><div class="info" id="MessageList"></div></td>
												</tr>
											</table>										
										</td>
									</tr>	
									<tr>
										<td>
											<table>
												<tr>
													<td class="vpPassIcon" width="10px"></td>
													<td><div class="pass"><xsl:value-of select="$rft.testlog.rpane.totalverdict.vp.pass"/></div></td>
													<td>:</td>
													<td><div class="pass" id="SuccessVPList"></div></td>											
												</tr>
												<tr>
													<td class="vpFailIcon" width="10px"></td>
													<td><div class="fail"><xsl:value-of select="$rft.testlog.rpane.totalverdict.vp.fail"/></div></td>
													<td>:</td>
													<td><div class="fail" id="FailureVPList"></div></td>												
												</tr>
											</table>									
										</td>
									</tr>
								</table>				
							
							
							</div>
						
							<TABLE id="RightVerdictDetailsTable" border="1" rules="rows" width="100%" summary="Log Events">
								<xsl:apply-templates select="Event/Event" mode="tableCreation"></xsl:apply-templates>
								<xsl:apply-templates select="Event" mode="tableCreation"></xsl:apply-templates>
							
							</TABLE>
						
								
						
						<div id="RightVerdictBottomContainer" dojoType="dijit.layout.LayoutContainer" layoutAlign="bottom" sizeShare="10" >
							<div id="RightVerdictBottomDatapool" dojoType="dijit.TitlePane" open="false"  title="{$rft.testlog.rpane.dp.headline}" >
							
								<table id="dpTable"  border="1">
								<tr id="dpVariable" align="center" ></tr>
								<tr id="dpValue" align="center"></tr>
								</table>
	
							</div>
							<!-- div id="RightVerdictBottomDefect" dojoType="dijit.TitlePane" open="false"  title="Defect Submission">
							<a href="http://bugs.eclipse.org/bugs">Submit the defect</a>							
							</div -->						
						</div>
					</div>			
			</div>
		</div>
	</div>
	<script type="text/javascript">
	<xsl:if test="$dojoJSLocation = '../Log_Assistive_Files/dojo.js'">
		if(!location.search)
		{
			var topTag = document.getElementById("TopPane");
			topTag.innerHTML = "";
			
			
			var inputElement = document.createElement("input");
			inputElement.type = "file";
			inputElement.id = "dojolocation";
			topTag.appendChild(inputElement);
			var openLog  = document.createElement("input");
			openLog.type = "button";
			openLog.id = "openlog";
			openLog.value = "Open Log";
			openLog.onclick = function(){
						var dojoLoc = document.getElementById("dojolocation").value;
						var newLoc = location.href + "?" + dojoLoc;
						location.assign(newLoc);
			};
			topTag.appendChild(openLog);


		}
		else
		{
		</xsl:if>
			var sucCount = dojo.byId("SuccessList");
			sucCount.innerHTML =  verdictSuccess;
			sucCount = dojo.byId("FailureList");
			sucCount.innerHTML =  verdictFailures;
			sucCount = dojo.byId("WarningList");
			sucCount.innerHTML =  verdictWarnings;
			sucCount = dojo.byId("MessageList");
			sucCount.innerHTML =  verdictMessages;
			sucCount = dojo.byId("SuccessVPList");
			sucCount.innerHTML =  verdictVPSuccess;
			sucCount = dojo.byId("FailureVPList");	
			sucCount.innerHTML = verdictVPFailures;
		<xsl:if test="$dojoJSLocation = '../Log_Assistive_Files/dojo.js'">
		}
		</xsl:if>
</script>

	<APPLET CODE="com/rational/test/ft/bootstrap/HtmlLogComparatorApplet.class" NAME="ComparatorApplet" WIDTH="0" HEIGHT="0"></APPLET>
	</BODY>
	
	</HTML>
	</xsl:template>
	
	<xsl:template match="Event" mode="treeElements1">		
	<xsl:if test="Event">
		<xsl:apply-templates select="Event" mode="treeElements">
		<xsl:with-param name="index" select="position()"></xsl:with-param>
		</xsl:apply-templates>
	</xsl:if>
	</xsl:template>
	
	<xsl:template match="Event" mode="treeElements">
	<xsl:param name = "index" select="-1"/>		

	<xsl:variable name="eventType">
	<xsl:value-of select="@Type"/>
	</xsl:variable>
	
	<xsl:variable name="eventId" >
	<xsl:text>event_</xsl:text>
	<xsl:value-of select="Property/@script_name"/>
	<xsl:text>_</xsl:text>
	<xsl:value-of select="generate-id()"/>
	</xsl:variable>
	
	<xsl:variable name="eventParentId" >
	<xsl:text>event_</xsl:text>
	<xsl:value-of select="../Event/Property/@script_name"/>
	<xsl:text>_</xsl:text>
	<xsl:choose>
	<xsl:when test="./../@Type ='Simplified Script Group'">
		<xsl:apply-templates select="parent::Event" mode="parentID"/>
	</xsl:when>
	<xsl:otherwise>
		<xsl:value-of select="generate-id(../Event)"/>
	</xsl:otherwise>
	</xsl:choose>
	</xsl:variable>
	
	<xsl:if test="$eventType = 'Script Start'">		
	<xsl:if test="(number(./../@dpIter) > 0) or ($index &gt; 1)">,</xsl:if>{ eventType: 'rftevent', eventId: '<xsl:value-of select="$eventId"/>_root', TimeStamp: '<xsl:value-of select="@Timestamp"/>' ,Headline: '<xsl:value-of select="translate(@Headline,$singleQuote,'')"/>', Type: '<xsl:value-of select="@Type"/>', Result: '<xsl:value-of select="@Result"/>', Position: '<xsl:value-of select="position()"/>', ParentId: '<xsl:value-of select="$eventParentId"/>_root', events: [
	</xsl:if>
	
	<xsl:choose>
	<xsl:when test="$eventType='Simplified Script Group'"><xsl:if test="position() &gt; 1">,</xsl:if>{ eventType: 'rftevent', eventId: '<xsl:value-of select="$eventId"/>', TimeStamp: '<xsl:value-of select="@Timestamp"/>' ,Headline: '<xsl:value-of select="translate(@Headline,$singleQuote,'')"/>', Type: '<xsl:value-of select="@Type"/>', Result: '<xsl:apply-templates select="." mode="getResult"/>', Position: '<xsl:value-of select="position()"/>', ParentId: '<xsl:value-of select="$eventParentId"/>_root'<xsl:if test="Event">,events: [</xsl:if>	<xsl:apply-templates select="Event" mode="treeElements"><xsl:with-param name="index" select="position()"></xsl:with-param></xsl:apply-templates>
		<xsl:if test="Event">]</xsl:if>}
	</xsl:when>
	<xsl:otherwise><xsl:if test="position() &gt; 1">,</xsl:if>{ eventType: 'rftevent', eventId: '<xsl:value-of select="$eventId"/>', TimeStamp: '<xsl:value-of select="@Timestamp"/>' ,Headline: '<xsl:value-of select="translate(@Headline,$singleQuote,'')"/>', Type: '<xsl:value-of select="@Type"/>', Result: '<xsl:value-of select="@Result"/>', Position: '<xsl:value-of select="position()"/>', ParentId: '<xsl:value-of select="$eventParentId"/>_root'<xsl:if test="Event/Event"> ,events: [<xsl:apply-templates select="Event" mode="treeElements1"/>]</xsl:if>}	
	</xsl:otherwise>
	</xsl:choose>

	<xsl:if test="$eventType = 'Script End'">]}</xsl:if>
	</xsl:template>	
	
	<xsl:template match="Event" mode="getResult">
			<xsl:variable name="countFail">
			<xsl:for-each select="descendant::Event[@Result = 'FAIL']">
				FAIL
			</xsl:for-each>
			</xsl:variable>
			
			<!--<TD class="status"><xsl:value-of select="$rft.testlog.rpane.totalverdict.fail"/></TD>-->
			<xsl:variable name="countWarn">
			<xsl:for-each select="descendant::Event[@Result = 'WARNING']">
				WARN
			</xsl:for-each>
			</xsl:variable>
			
			<xsl:variable name="countPass">
			<xsl:for-each select="descendant::Event[@Result = 'PASS']">
				PASS
			</xsl:for-each>  
			</xsl:variable>
			
								
			<xsl:choose>
				<xsl:when test="contains($countFail,'FAIL')">
					<xsl:value-of select="$rft.testlog.rpane.resulttable.fail"/>
				</xsl:when>
				<xsl:when test="contains($countWarn,'WARN')">
					<xsl:value-of select="$rft.testlog.rpane.resulttable.warn"/>
				</xsl:when>							
				<xsl:when test="contains($countPass,'PASS')">
					<xsl:value-of select="$rft.testlog.rpane.resulttable.pass"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="$rft.testlog.rpane.resulttable.pass"/>
				</xsl:otherwise>			
			</xsl:choose>
			
	</xsl:template>
	
	
	<xsl:template match="Event" mode="parentID">
		<xsl:choose>
		<xsl:when test="number(@dpIter) >= 0">
			<xsl:if test="./Event/@Type = 'Script Start'"><xsl:value-of select="generate-id(./Event)"/></xsl:if>
		</xsl:when>
		<xsl:otherwise>
			<xsl:apply-templates select="parent::Event" mode="parentID"/>
		</xsl:otherwise>		
		</xsl:choose>
	</xsl:template>	
		
	<xsl:template match="Event" mode="tableCreation">	
	
	<xsl:variable name="eventType">
	<xsl:value-of select="@Type"/>
	</xsl:variable>
	
	
	<xsl:variable name="eventId" >
	<xsl:text>event_</xsl:text>
	<xsl:value-of select="Property/@script_name"/>
	<xsl:text>_</xsl:text>
	<xsl:value-of select="generate-id()"/>
	</xsl:variable>	
	
	<xsl:choose>
		<xsl:when test="$eventType = 'Simplified Script Group'">
		<TR id = "{$eventId}" >
			
			<xsl:variable name="countFail">
			<xsl:for-each select="descendant::Event[@Result = 'FAIL']">
				FAIL
			</xsl:for-each>
			</xsl:variable>
			
			<!--<TD class="status"><xsl:value-of select="$rft.testlog.rpane.totalverdict.fail"/></TD>-->
			<xsl:variable name="countWarn">
			<xsl:for-each select="descendant::Event[@Result = 'WARNING']">
				WARN
			</xsl:for-each>
			</xsl:variable>
			
			<xsl:variable name="countPass">
			<xsl:for-each select="descendant::Event[@Result = 'PASS']">
				PASS
			</xsl:for-each>  
			</xsl:variable>
			
								
			<xsl:choose>
				<xsl:when test="contains($countFail,'FAIL')">
					<TD class="failStatus" ><xsl:value-of select="$rft.testlog.rpane.resulttable.fail"/></TD>
				</xsl:when>
				<xsl:when test="contains($countWarn,'WARN')">
					<TD class="warnStatus" ><xsl:value-of select="$rft.testlog.rpane.resulttable.warn"/></TD>
				</xsl:when>							
				<xsl:when test="contains($countPass,'PASS')">
					<TD class="passStatus"><xsl:value-of select="$rft.testlog.rpane.resulttable.pass"/></TD>
				</xsl:when>
				<xsl:otherwise>
					<TD class="passStatus" ><xsl:value-of select="$rft.testlog.rpane.resulttable.pass"/></TD>
				</xsl:otherwise>			
			</xsl:choose>
			
			
			
			<xsl:for-each select="Event[last()]">
					
						<xsl:variable name="nestedEventType">
							<xsl:value-of select="@Type"/>
						</xsl:variable>
						<xsl:if test="$nestedEventType = 'Timer End'">
							<xsl:variable name="TimeElapsed" >		
									<xsl:value-of select="Property/@elapsed_time"/>
							</xsl:variable>
							<TD class="timeElapsed"><xsl:value-of select="$TimeElapsed"/></TD>
						</xsl:if>
			</xsl:for-each>
			<xsl:if test="Event[last()]/@Type !='Timer End'">
						<TD class="timeElapsed"></TD>
			</xsl:if>
			
		
			<TD class="ssheadline"><xsl:value-of select="@Headline"/></TD>				
		</TR>
			<TR>
		<TD COLSPAN='3'>
		<UL>
			<xsl:for-each select="Property">
				<LI><xsl:apply-templates select="@*"></xsl:apply-templates></LI>
			</xsl:for-each>						
		 </UL>
		</TD>
	</TR>
		
		<xsl:if test="*">	
			<xsl:apply-templates select="*" mode="tableCreation"></xsl:apply-templates>	
		</xsl:if>	
						
		</xsl:when>
		
		<xsl:otherwise>
		<TR id = "{$eventId}" >

		<xsl:variable name="result" >
			<xsl:choose>
			<xsl:when test="@Result = 'PASS'">pass</xsl:when>
			<xsl:when test="@Result = 'FAIL'">fail</xsl:when>
			<xsl:when test="@Result = 'WARNING'">warn</xsl:when>
			<xsl:when test="@Result = 'INFORMATION'">info</xsl:when>
			<xsl:otherwise>unkn</xsl:otherwise>
			</xsl:choose>
		</xsl:variable>	
		
		<xsl:variable name="resultValue" >
			<xsl:choose>
			<xsl:when test="@Result = 'PASS'"><xsl:value-of select="$rft.testlog.rpane.resulttable.pass"/></xsl:when>
			<xsl:when test="@Result = 'FAIL'"><xsl:value-of select="$rft.testlog.rpane.resulttable.fail"/></xsl:when>
			<xsl:when test="@Result = 'WARNING'"><xsl:value-of select="$rft.testlog.rpane.resulttable.warn"/></xsl:when>
			<xsl:when test="@Result = 'INFORMATION'"><xsl:value-of select="$rft.testlog.rpane.resulttable.info"/></xsl:when>
			<xsl:otherwise><xsl:value-of select="$rft.testlog.rpane.resulttable.info"/></xsl:otherwise>
			</xsl:choose>
		</xsl:variable>	
		
		<TD class="{$result}"><xsl:value-of select="$resultValue"/></TD>
		<TD class="time"><xsl:value-of select="@Timestamp"/></TD>
		<TD class="note"><xsl:value-of select="@Headline"/></TD>
	</TR>
	
	<TR>
		<TD COLSPAN='3'>
			<UL>
			<xsl:for-each select="Property">
				<LI><xsl:apply-templates select="@*"></xsl:apply-templates></LI>
			</xsl:for-each>		
				
			<xsl:if test="Property/@expected">
				<xsl:variable name="exp" >
					<xsl:text>'</xsl:text><xsl:value-of select="Property/@expected"/><xsl:text>'</xsl:text>
				</xsl:variable>

				<xsl:variable name="act">
				<xsl:choose>
				<xsl:when test="Property/@actual">
					<xsl:text>'</xsl:text><xsl:value-of select="Property/@actual"/><xsl:text>'</xsl:text>
				</xsl:when>
				<xsl:otherwise>null</xsl:otherwise>
				</xsl:choose>
				</xsl:variable>
				
				<xsl:variable name="base">
				<xsl:choose>
				<xsl:when test="Property/@baseline">
					<xsl:text>'</xsl:text><xsl:value-of select="Property/@baseline"/><xsl:text>'</xsl:text>
				</xsl:when>
				<xsl:otherwise>null</xsl:otherwise>
				</xsl:choose>
				</xsl:variable>

				<P><A HREF="#" onClick="javascript:comparator({translate($base,'\','/')},{$exp},{$act})"><xsl:value-of select="$rft.testlog.rpane.resulttable.vp.viewresult"/></A></P>
			</xsl:if>
			
			<xsl:if test="Property/@screen_snapshot">
				<xsl:variable name="snapShot" select="Property/@screen_snapshot"/>
				<LI><I>screen_snapshot = </I><A HREF="{$snapShot}"> <img src="{$snapShot}" height="120" width="160" align="middle"/><xsl:value-of select="$rft.testlog.rpane.resulttable.snapshot.click"/></A></LI>
			</xsl:if>

			<xsl:if test="Property/@user_screen_snapshot">
				<xsl:variable name="userSnapShot" select="Property/@user_screen_snapshot"/>
				<xsl:variable name="imageWidth">
					<xsl:choose>
						<xsl:when test="Property/@image_width = ''">160</xsl:when>
						<xsl:otherwise><xsl:value-of select="Property/@image_width"/></xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
			
				<xsl:variable name="imageHeight" >
					<xsl:choose>
						<xsl:when test="Property/@image_height = ''">120</xsl:when>
						<xsl:otherwise><xsl:value-of select="Property/@image_height"/></xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:variable name="maximus">
					<xsl:choose>
						<xsl:when test="$imageWidth > $imageHeight"><xsl:value-of select="$imageWidth"/></xsl:when>
						<xsl:otherwise><xsl:value-of select="$imageHeight"/></xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:variable name="scaledWidth">
					<xsl:choose>
						<xsl:when test ="$maximus > 160"><xsl:value-of select="floor($imageWidth * (160 div $maximus))"/></xsl:when>
						<xsl:otherwise><xsl:value-of select="$imageWidth"/></xsl:otherwise>
					</xsl:choose>
				</xsl:variable>
				<xsl:variable name="scaledHeight">
					<xsl:choose>
						<xsl:when test ="$maximus > 160"><xsl:value-of select="floor($imageHeight * (160 div $maximus))"/></xsl:when>
						<xsl:otherwise><xsl:value-of select="$imageHeight"/></xsl:otherwise>
					</xsl:choose>
				</xsl:variable>

				<LI><I>user_screen_snapshot = </I><A HREF="{$userSnapShot}"> <img src="{$userSnapShot}" height="{$scaledHeight}" width="{$scaledWidth}" align="middle"/><xsl:value-of select="$rft.testlog.rpane.resulttable.snapshot.click"/></A></LI>
			</xsl:if>
		 </UL>
		</TD>
	</TR>
	<xsl:if test="Event/Event">	
		<xsl:apply-templates select="Event/Event" mode="tableCreation"></xsl:apply-templates>	
	</xsl:if>	
						
		</xsl:otherwise>
	</xsl:choose>


	

	</xsl:template>
	
	
	
	<xsl:template match="Event" mode="dpStore">		
	<xsl:if test="@Type = 'Script Start'">
	<xsl:for-each select="../Event">
		<xsl:variable name="eventPosition" select="position()"/>		
		
		<xsl:if test="@Type = 'Script Start'">
		<xsl:variable name="eventId" >
			<xsl:text>dp_</xsl:text>
			<xsl:value-of select="Property/@script_name"/>
			<xsl:text>_</xsl:text>
			<xsl:value-of select="generate-id()"/>
		</xsl:variable>			
		dpLogStore.newItem({dpId: '<xsl:value-of select="$eventId"/>', dpUpdates: [	
		</xsl:if>					
		
		<xsl:for-each select = "dpStore/dpVariable/@*">
			<xsl:if test="($eventPosition &gt; 1) or (position() &gt; 1)">,</xsl:if>{CPosition : '<xsl:value-of select="$eventPosition"/>', dpVariable: '<xsl:value-of select="name()" />' , dpValue: '<xsl:value-of select="."/>' }
		</xsl:for-each>

		<xsl:if test="@Type = 'Script End'">]});</xsl:if>		
	</xsl:for-each>	
	</xsl:if>

	<xsl:choose>
	<xsl:when test="@Type ='Simplified Script Group'">
		<xsl:if test="Event">	
			<xsl:apply-templates select="Event" mode="dpStore" />		
		</xsl:if>
	</xsl:when>
	<xsl:otherwise>
	<xsl:if test="Event/Event">	
		<xsl:apply-templates select="Event/Event" mode="dpStore" />
	</xsl:if>	
	</xsl:otherwise>
	</xsl:choose>
	</xsl:template>



	<xsl:template match="@name">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.prop.name"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
	<xsl:template match="@line_number">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.script.line"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>

	<xsl:template match="@script_name">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.script.name"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>

	<xsl:template match="@script_id">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.script.id"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
	<xsl:template match="@vp_type">	
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.vp.type"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
	<xsl:template match="@actual">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.vp.actual"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
	<xsl:template match="@expected">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.vp.expected"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
	<xsl:template match="@baseline">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.vp.baseline"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
	<xsl:template match="@exception_name">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.exception.name"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
	<xsl:template match="@exception_message">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.exception.message"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
	<xsl:template match="@exception_stack">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.exception.stack"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
	<xsl:template match="@screen_snapshot">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.snapshot"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>

	<xsl:template match="@user_screen_snapshot">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.user.snapshot"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>

	<xsl:template match="@additional_info">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.additionalinfo"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>

	<xsl:template match="@failure_description">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.failure.desc"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
	<xsl:template match="@script_iter_count">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.script.itercount"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>	

	<xsl:template match="@simplifiedscript_line_number">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.script.ss_line_number"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>

	<xsl:template match="@simplifiedscript_line">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.script.ss_line"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
	<xsl:template match="@simplifiedscript_group_name">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.script.ss_group_name"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>

	<xsl:template match="@startapp_executable">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.script.sa_executable"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
	<xsl:template match="@startapp_arguments">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.script.sa_args"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>

	<xsl:template match="@startapp_working_direcotry">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.script.sa_work_dir"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>

	<xsl:template match="@startapp_type">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.script.sa_app_type"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>

	
	<xsl:template match="@property_name">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.script.property_name"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>

	<xsl:template match="@property_value">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.script.property_value"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>

	<xsl:template match="@assigned_variable_name">
	<I><xsl:value-of select="$rft.testlog.rpane.resulttable.script.assigned_variable_name"/> = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>

	<xsl:template match="@image_width">
	</xsl:template>

	<xsl:template match="@image_height">	
	</xsl:template>
	
	
</xsl:stylesheet>

