<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    version="1.0"
    xmlns:xalan="http://xml.apache.org/xslt">
	
    <xsl:output method="html"/>	      
    <xsl:param name="index" select="1"/>
    <xsl:template match="TestLog">	
	<HTML>
	<HEAD>
	<STYLE TYPE="text/css">
	<!--
	 table caption {color: darkblue; font-size: x-large; font-weight: bold}
	  td {align: left; font-weight: bold}
	  td.fail {color: darkred; width: 10% }
	  td.warn {color: darkgoldenrod; width: 10% }
	  td.pass {color: darkgreen; width: 10% }
	  td.unkn {color: darkcyan; width: 10% }
	  td.info {width: 10% }
	  td.time {width: 30%; font-weight: normal}
	  td.note {align: left; font-weight: bold}
	  li {font-weight: normal}
	/-->
	</STYLE>
	
	</HEAD>	
		<BODY >
			<div id="TopPane" style="width: 100%; height:100%; overflow: auto;">
				<TABLE id="RightVerdictDetailsTable" border="1" rules="rows" width="100%" summary="Log Events">
					<xsl:apply-templates select="Event/Event" mode="tableCreation"></xsl:apply-templates>
					<xsl:apply-templates select="Event" mode="tableCreation"></xsl:apply-templates>
				</TABLE>
			</div>
		</BODY>
		</HTML>
	</xsl:template>
	
	<xsl:template match="Event" mode="treeElements1">		
		<xsl:if test="Event">
			<xsl:apply-templates select="Event" mode="treeElements">
			<xsl:with-param name="index" select="position()"></xsl:with-param>
			</xsl:apply-templates>
		</xsl:if>
	</xsl:template>
	
	<xsl:template match="Event" mode="treeElements">
		<xsl:param name = "index" select="-1"/>		

		<xsl:variable name="eventType">
		<xsl:value-of select="@Type"/>
		</xsl:variable>
		
		<xsl:variable name="eventId" >
		<xsl:text>event_</xsl:text>
		<xsl:value-of select="Property/@script_name"/>
		<xsl:text>_</xsl:text>
		<xsl:value-of select="generate-id()"/>
		</xsl:variable>
		
		<xsl:variable name="eventParentId" >
		<xsl:text>event_</xsl:text>
		<xsl:value-of select="../Event/Property/@script_name"/>
		<xsl:text>_</xsl:text>
		<xsl:choose>
		<xsl:when test="./../@Type ='Simplified Script Group'">
			<xsl:apply-templates select="parent::Event" mode="parentID"/>
		</xsl:when>
		<xsl:otherwise>
			<xsl:value-of select="generate-id(../Event)"/>
		</xsl:otherwise>
		</xsl:choose>
		</xsl:variable>
		
		<xsl:if test="$eventType = 'Script Start'">		
		<xsl:if test="(number(./../@dpIter) > 0) or ($index &gt; 1)">,</xsl:if>{ eventType: 'rftevent', eventId: '<xsl:value-of select="$eventId"/>_root', TimeStamp: '<xsl:value-of select="@Timestamp"/>' ,Headline: '<xsl:value-of select="@Headline"/>', Type: '<xsl:value-of select="@Type"/>', Result: '<xsl:value-of select="@Result"/>', Position: '<xsl:value-of select="position()"/>', ParentId: '<xsl:value-of select="$eventParentId"/>_root', events: [
		</xsl:if>
		
		<xsl:choose>
		<xsl:when test="$eventType='Simplified Script Group'"><xsl:if test="position() &gt; 1">,</xsl:if>{ eventType: 'rftevent', eventId: '<xsl:value-of select="$eventId"/>', TimeStamp: '<xsl:value-of select="@Timestamp"/>' ,Headline: '<xsl:value-of select="@Headline"/>', Type: '<xsl:value-of select="@Type"/>', Result: '<xsl:apply-templates select="." mode="getResult"/>', Position: '<xsl:value-of select="position()"/>', ParentId: '<xsl:value-of select="$eventParentId"/>_root'<xsl:if test="Event">,events: [</xsl:if>	<xsl:apply-templates select="Event" mode="treeElements"><xsl:with-param name="index" select="position()"></xsl:with-param></xsl:apply-templates>
			<xsl:if test="Event">]</xsl:if>}
		</xsl:when>
		<xsl:otherwise><xsl:if test="position() &gt; 1">,</xsl:if>{ eventType: 'rftevent', eventId: '<xsl:value-of select="$eventId"/>', TimeStamp: '<xsl:value-of select="@Timestamp"/>' ,Headline: '<xsl:value-of select="@Headline"/>', Type: '<xsl:value-of select="@Type"/>', Result: '<xsl:value-of select="@Result"/>', Position: '<xsl:value-of select="position()"/>', ParentId: '<xsl:value-of select="$eventParentId"/>_root'<xsl:if test="Event/Event"> ,events: [<xsl:apply-templates select="Event" mode="treeElements1"/>]</xsl:if>}	
		</xsl:otherwise>
		</xsl:choose>

		<xsl:if test="$eventType = 'Script End'">]}</xsl:if>
	</xsl:template>	
		
	<xsl:template match="Event" mode="tableCreation">	
	
		<xsl:variable name="eventType">
			<xsl:value-of select="@Type"/>
		</xsl:variable>
	
		<xsl:variable name="eventId" >
			<xsl:text>event_</xsl:text>
			<xsl:value-of select="Property/@script_name"/>
			<xsl:text>_</xsl:text>
			<xsl:value-of select="generate-id()"/>
		</xsl:variable>	

		<xsl:if test="(@Type != 'Timer Start') and (@Type != 'Timer End')">
			<TR id = "{$eventId}" >
				<xsl:variable name="verdict">		
						<xsl:if test="@Result = 'PASS'">pass></xsl:if>
						<xsl:if test="@Result = 'FAIL'">fail</xsl:if>
						<xsl:if test="@Result = 'WARNING'">warning</xsl:if>											
						<xsl:if test="@Result = 'INFORMATION'">info</xsl:if>
				</xsl:variable>

				<TD CLASS="{$verdict}"><xsl:value-of select="@Result"/></TD>
				<TD CLASS="time"><xsl:value-of select="@Timestamp"/></TD>
				<TD CLASS="note"><xsl:value-of select="@Headline"/></TD>
			</TR>
		
			<TR>
				<TD COLSPAN='3'>
					<UL>
						<xsl:for-each select="Property">
								<LI><xsl:apply-templates select="@*"></xsl:apply-templates></LI>
						</xsl:for-each>				
					</UL>
				</TD>
			</TR>
		</xsl:if>
		<xsl:choose>
			<xsl:when test="$eventType = 'Simplified Script Group'">
				<TR id = "{$eventId}" >
					<TD class="ssheadline"><xsl:value-of select="@Headline"/></TD>				
				</TR>
				<TR>
					<TD COLSPAN='3'>
						<UL>
							<xsl:for-each select="Property">
								<LI><xsl:apply-templates select="@*"></xsl:apply-templates></LI>
							</xsl:for-each>						
						 </UL>
					</TD>
				</TR>
				<xsl:if test="*">	
					<xsl:apply-templates select="*" mode="tableCreation"></xsl:apply-templates>	
				</xsl:if>	
			</xsl:when>
		</xsl:choose>
		<xsl:if test="Event/Event">	
			<xsl:apply-templates select="Event/Event" mode="tableCreation"></xsl:apply-templates>	
		</xsl:if>	
	</xsl:template>
	
	
	
	<xsl:template match="Event" mode="dpStore">		
		<xsl:if test="@Type = 'Script Start'">
			<xsl:for-each select="../Event">
				<xsl:variable name="eventPosition" select="position()"/>		
				
				<xsl:if test="@Type = 'Script Start'">
				<xsl:variable name="eventId" >
					<xsl:text>dp_</xsl:text>
					<xsl:value-of select="Property/@script_name"/>
					<xsl:text>_</xsl:text>
					<xsl:value-of select="generate-id()"/>
				</xsl:variable>			
				dpLogStore.newItem({dpId: '<xsl:value-of select="$eventId"/>', dpUpdates: [	
				</xsl:if>					
				
				<xsl:for-each select = "dpStore/dpVariable/@*">
					<xsl:if test="($eventPosition &gt; 1) or (position() &gt; 1)">,</xsl:if>{CPosition : '<xsl:value-of select="$eventPosition"/>', dpVariable: '<xsl:value-of select="name()" />' , dpValue: '<xsl:value-of select="."/>' }
				</xsl:for-each>

				<xsl:if test="@Type = 'Script End'">]});</xsl:if>		
			</xsl:for-each>	
		</xsl:if>
		
		<xsl:choose>
			<xsl:when test="@Type ='Simplified Script Group'">
				<xsl:if test="Event">	
					<xsl:apply-templates select="Event" mode="dpStore" />		
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
				<xsl:if test="Event/Event">	
					<xsl:apply-templates select="Event/Event" mode="dpStore" />
				</xsl:if>	
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>



	<xsl:template match="@name">
	<I>Name = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
	<xsl:template match="@line_number">
	<I>Line Number = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>

	<xsl:template match="@script_name">
	<I>Script Name = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>

	<xsl:template match="@script_id">
	<I>Script Id = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>

	<xsl:template match="@name">
	<I>Name = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
	<xsl:template match="@simplifiedscript_group_name">
	<I>Simplified Script Group Names = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
	<xsl:template match="@property_name">
	<I>Property Name = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
	<xsl:template match="@simplifiedscript_line_number">
	<I>Simplified Script Line number = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
	<xsl:template match="@additional_info">
	<I>Additional Info = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
	<xsl:template match="@script_iter_count">
	<I>Script Iteration count = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>	
	
	<xsl:template match="@baseline">
	<I>Baseline verification Point = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
	<xsl:template match="@expected">
	<I>Expected Verification Point= </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
	<xsl:template match="@actual">
	<I>Actual Verification Point = </I><xsl:value-of select="."></xsl:value-of>
	</xsl:template>
	
</xsl:stylesheet>